//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

//Parametres d'ouverture de position
extern int FastMA_PeriodO = 40;
extern int SlowMA_PeriodO = 200;
//Parametres de fermeture de position
extern int FastMA_PeriodC = 3;
extern int SlowMA_PeriodC = 199;
//Parametres de Traiding
extern int StopLoss = 200;
extern int TrailingStop = 40;
extern int TakeProfit = 0;

extern bool UseStopLoss = True;
extern bool UseTrailingStop = True;
extern bool UseTakeProfit = False;

extern int MagicNumber = 13611;
extern bool SignalMail = False;
extern bool EachTickMode = True;
extern double Lots = 0.01;
extern int Slippage = 3;

int BarCount;
int Current;
bool TickCheck = False;

//PARAMETRES POUR 5 DIGITS
double Poin;
int Deviation;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
{
         //Checking for unconvetional Point digits number
            if ((Point == 0.00001) || (Point == 0.001))
            {Poin = Point * 10;
             Deviation = Slippage * 10;}
            else
            {Poin = Point; //Normal
             Deviation = Slippage;
             return(0);}

   BarCount = Bars;
   if (EachTickMode) Current = 0; else Current = 1;
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+
double Buy1_1 = iMA(NULL, 0, FastMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double Buy1_2 = iMA(NULL, 0, SlowMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double Buy2_1 = iMA(NULL, 0, FastMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
double Buy2_2 = iMA(NULL, 0, SlowMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 0);

double Sell1_1 = iMA(NULL, 0, FastMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double Sell1_2 = iMA(NULL, 0, SlowMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double Sell2_1 = iMA(NULL, 0, FastMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
double Sell2_2 = iMA(NULL, 0, SlowMA_PeriodO, 0, MODE_EMA, PRICE_CLOSE, Current + 0);

double CloseBuy1_1 = iMA(NULL, 0, FastMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double CloseBuy1_2 = iMA(NULL, 0, SlowMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double CloseBuy2_1 = iMA(NULL, 0, FastMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
double CloseBuy2_2 = iMA(NULL, 0, SlowMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 0);

double CloseSell1_1 = iMA(NULL, 0, FastMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double CloseSell1_2 = iMA(NULL, 0, SlowMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
double CloseSell2_1 = iMA(NULL, 0, FastMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
double CloseSell2_2 = iMA(NULL, 0, SlowMA_PeriodC, 0, MODE_EMA, PRICE_CLOSE, Current + 0);

   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+
   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+
                     if (CloseBuy1_1 > CloseBuy1_2 && CloseBuy2_1 < CloseBuy2_2) Order = SIGNAL_CLOSEBUY;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Poin * TrailingStop) {
                  if(OrderStopLoss() < Bid - Poin * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Poin * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+
                     if (CloseSell1_1 < CloseSell1_2 && CloseSell2_1 > CloseSell2_2) Order = SIGNAL_CLOSESELL;


            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+
            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Poin * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Poin * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Poin * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+
   if (Buy1_1 < Buy1_2 && Buy2_1 > Buy2_2) Order = SIGNAL_BUY;

   if (Sell1_1 > Sell1_2 && Sell2_1 < Sell2_2) Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Poin; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Poin; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         
         
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                //if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			 
			 //NOT SURE STOPLOSS IS WORKING
			 Ticket = OrderModify(OrderTicket(), OrderOpenPrice(), StopLossLevel, TakeProfitLevel, 0);
			//-----------------------------
			
			} else 
			{
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }
 
   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade)
      {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots))
         {Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);}

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Poin; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Poin; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, 0, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         
         if(Ticket > 0)
          {if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES))
            {Print("SELL order opened : ", OrderOpenPrice());
           // if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");

			//NOT SURE STOPLOSS IS WORKING
         Ticket = OrderModify(OrderTicket(), OrderOpenPrice(), StopLossLevel, TakeProfitLevel, 0);
         //------------------------------

			} 
			else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }


   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+